%global namedreltag .RC1
%global namedreltag2 RC1
%global namedversion %{version}-%{?namedreltag2}
%global namedversion2 %{version}%{?namedreltag}

Name: resteasy
Version: 2.3
Release: 0.1%{namedreltag}%{?dist}
Summary: RESTEasy framework for RESTful Web services and Java applications
Group: Development/Libraries
License: ASL 2.0
URL: http://www.jboss.org/resteasy

# svn export https://resteasy.svn.sourceforge.net/svnroot/resteasy/tags/RESTEASY_2_3_RC_1 resteasy-2.3.RC1
# tar -caJf resteasy-2.3.RC1.tar.xz resteasy-2.3.RC1
Source0: %{name}-%{namedversion2}.tar.xz

Patch0: %{name}-%{namedversion2}-remove-dependenciesA.patch
Patch1: %{name}-%{namedversion2}-fix-tests.patch

BuildArch: noarch

BuildRequires: apache-commons-lang
BuildRequires: apache-commons-cli
BuildRequires: apache-commons-codec
BuildRequires: apache-commons-logging
BuildRequires: apache-commons-collections
BuildRequires: apache-mime4j

BuildRequires: bea-stax
BuildRequires: bouncycastle
BuildRequires: bouncycastle-mail
BuildRequires: cglib
BuildRequires: codehaus-parent
BuildRequires: dnsjava
BuildRequires: glassfish-jaxb
BuildRequires: glassfish-jaxb-api
BuildRequires: google-guice
# BuildRequires: hibernate3-ejb3-persistence-3.0-api
# BuildRequires: hibernate-validator
BuildRequires: httpcomponents-client
BuildRequires: httpcomponents-core
BuildRequires: hsqldb
BuildRequires: httpunit
BuildRequires: jackson
BuildRequires: jakarta-commons-httpclient
BuildRequires: javamail
BuildRequires: javassist
BuildRequires: jboss-annotations-api
##BuildRequires: jboss-ejb3-ext-api
BuildRequires: jboss-el-2.2-api
# BuildRequires: jboss-servlet-3.0-api
# BuildRequires: jbosscache-core
BuildRequires: jboss-web
BuildRequires: jcip-annotations
BuildRequires: jettison
BuildRequires: jetty
BuildRequires: junit4
BuildRequires: istack-commons
# BuildRequires: jyaml
# BuildRequires: liblog4j-java

# BuildRequires: oauth
BuildRequires: scannotation
BuildRequires: slf4j
BuildRequires: snakeyaml
#BuildRequires: spring3-core
#BuildRequires: spring3-test
#BuildRequires: spring3-web-servlet
BuildRequires: glassfish-fi
#BuildRequires: sun-sjsxp
BuildRequires: tomcat6
BuildRequires: tomcat6-lib
BuildRequires: tomcat6-servlet-2.5-api
BuildRequires: txw2
#BuildRequires: weld-cdi-api
BuildRequires: xerces-j2

#BuildRequires: findbugs-maven-plugin
BuildRequires: jetty-version-maven-plugin
BuildRequires: maven
BuildRequires: maven-checkstyle-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-deploy-plugin
BuildRequires: maven-install-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-jaxb2-plugin
BuildRequires: maven-plugin-cobertura
BuildRequires: maven-pmd-plugin
BuildRequires: maven-resources-plugin
BuildRequires: maven-site-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: maven-surefire-report-plugin

BuildRequires: jpackage-utils
BuildRequires: java-devel

Requires: jpackage-utils
Requires: java
Requires: scannotation
Requires: ws-jaxme
Requires: jettison

%description
RESTEasy is a JBoss project that provides various frameworks to help you build RESTful Web
Services and RESTful Java applications. It is a fully certified and portable implementation of the
JAX-RS specification. JAX-RS is a new JCP specification that provides a Java API for RESTful Web
Services over the HTTP protocol.

%package javadoc
Summary: Javadocs for %{name}
Group: Documentation
Requires: jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n %{name}-%{namedversion2}

%patch0 -p1 -b .p0
%patch1 -p1 -b .p1

%build
#mvn-rpmbuild  --fn -e install javadoc:aggregate
# Build a comman separated list of the modules to build:
names='
tjws
jaxrs-api
resteasy-jaxrs
providers
providers/jaxb
providers/jackson
providers/jettison
providers/yaml
providers/test-all-jaxb
providers/fastinfoset
providers/test-jackson-jaxb-coexistence
providers/resteasy-atom
providers/resteasy-html
providers/test-resteasy-html
async-http-jbossweb
async-http-jbossweb/async-http-jbossweb-jar
resteasy-jsapi
resteasy-bom
async-http-tomcat
async-http-tomcat/asynch-http-tomcat-jar
resteasy-test-data
resteasy-guice
'
list=`echo ${names} | sed 's/ /,/g'`

# Build without the tests:
#  -Dmaven.test.skip=true \
mvn-rpmbuild \
  -pl ${list} \
  install \
  javadoc:aggregate

%install
rm -rf %{buildroot}

#JAR
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -pm 644 async-http-jbossweb/async-http-jbossweb-jar/target/async-http-jbossweb-%{namedversion}.jar \
   %{buildroot}%{_javadir}/%{name}/async-http-jbossweb.jar
install -pm 644 async-http-tomcat/asynch-http-tomcat-jar/target/async-http-tomcat6-%{namedversion}.jar \
   %{buildroot}%{_javadir}/%{name}/async-http-tomcat6.jar
install -pm 644 jaxrs-api/target/jaxrs-api-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/jaxrs-api.jar
install -pm 644 providers/fastinfoset/target/%{name}-fastinfoset-provider-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/%{name}-fastinfoset-provider.jar
install -pm 644 providers/jackson/target/%{name}-jackson-provider-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/%{name}-jackson-provider.jar
install -pm 644 providers/jaxb/target/%{name}-jaxb-provider-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/%{name}-jaxb-provider.jar
install -pm 644 providers/jettison/target/%{name}-jettison-provider-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/%{name}-jettison-provider.jar
install -pm 644 providers/%{name}-atom/target/%{name}-atom-provider-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/%{name}-atom-provider.jar
install -pm 644 providers/%{name}-html/target/%{name}-html-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/%{name}-html.jar
install -pm 644 providers/test-all-jaxb/target/test-all-jaxb-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/test-all-jaxb.jar
install -pm 644 providers/test-jackson-jaxb-coexistence/target/test-jackson-jaxb-coexistence-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/test-jackson-jaxb-coexistence.jar
install -pm 644 providers/test-%{name}-html/target/test-%{name}-html-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/test-%{name}-html.jar
install -pm 644 providers/yaml/target/%{name}-yaml-provider-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/%{name}-yaml-provider.jar
install -pm 644 %{name}-guice/target/%{name}-guice-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/%{name}-guice.jar
install -pm 644 %{name}-jaxrs/target/%{name}-jaxrs-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/%{name}-jaxrs.jar
install -pm 644 %{name}-jsapi/target/%{name}-jsapi-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/%{name}-jsapi.jar
install -pm 644 %{name}-test-data/target/%{name}-test-data-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/%{name}-test-data.jar
install -pm 644 tjws/target/tjws-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}/tjws.jar

# To be added when jars build

# install -pm 644 async-http-servlet-3.0/async-http-servlet-3.0/target/async-http-servlet-3.0-%{namedversion}.jar \
#   %{buildroot}%{_javadir}/%{name}/async-http-servlet-3.0.jar
# install -pm 644 eagledns/target/eagledns-fork-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/eagledns-fork.jar
# install -pm 644 profiling-tests/target/profiling-tests-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/profiling-tests.jar
#install -pm 644 providers/multipart/target/%{name}-multipart-provider-%{namedversion}.jar \
#  %{buildroot}%{_javadir}/%{name}/%{name}-multipart-provider.jar
#install -pm 644 providers/%{name}-hibernatevalidator-provider/target/%{name}-hibernatevalidator-provider-%{namedversion}.jar \
#  %{buildroot}%{_javadir}/%{name}/%{name}-hibernatevalidator-provider.jar
#install -pm 644 %{name}-cache/%{name}-cache-core/target/%{name}-cache-core-%{namedversion}.jar \
#  %{buildroot}%{_javadir}/%{name}/%{name}-cache-core.jar
#install -pm 644 %{name}-cdi/target/%{name}-cdi-%{namedversion}.jar \
#  %{buildroot}%{_javadir}/%{name}/%{name}-cdi.jar
#install -pm 644 %{name}-links/target/%{name}-links-%{namedversion}.jar \
#  %{buildroot}%{_javadir}/%{name}/%{name}-links.jar
#install -pm 644 %{name}-spring/target/%{name}-spring.jar \
#  %{buildroot}%{_javadir}/%{name}/%{name}-spring.jar
#install -pm 644 security/%{name}-crypto/target/%{name}-crypto-%{namedversion}.jar \
#  %{buildroot}%{_javadir}/%{name}/%{name}-crypto.jar
#install -pm 644 security/%{name}-oauth/target/%{name}-oauth-%{namedversion}.jar \
#  %{buildroot}%{_javadir}/%{name}/%{name}-oauth.jar

# POM
install -d -m 755 $RPM_BUILD_ROOT%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-jaxrs-all.pom
%add_maven_depmap JPP.%{name}-jaxrs-all.pom

install -pm 644 %{name}-bom/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-bom.pom
%add_maven_depmap JPP.%{name}-bom.pom

install -pm 644 async-http-jbossweb/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-async-http-jbossweb-pom.pom
%add_maven_depmap JPP.%{name}-async-http-jbossweb-pom.pom

install -pm 644 async-http-jbossweb/async-http-jbossweb-jar/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-async-http-jbossweb.pom
%add_maven_depmap JPP.%{name}-async-http-jbossweb.pom %{name}/async-http-jbossweb.jar

install -pm 644 async-http-tomcat/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-async-http-tomcat-pom.pom
%add_maven_depmap JPP.%{name}-async-http-tomcat-pom.pom

install -pm 644 async-http-tomcat/asynch-http-tomcat-jar/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-async-http-tomcat6.pom
%add_maven_depmap JPP.%{name}-async-http-tomcat6.pom %{name}/async-http-tomcat6.jar

install -pm 644 jaxrs-api/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-jaxrs-api.pom
%add_maven_depmap JPP.%{name}-jaxrs-api.pom %{name}/jaxrs-api.jar

install -pm 644 providers/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-providers-pom.pom
%add_maven_depmap JPP.%{name}-providers-pom.pom

# install -pm 644 async-http-servlet-3.0/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-async-http-servlet-3.0-pom.pom
# add_maven_depmap JPP.%{name}-async-http-servlet-3.0-pom.pom

# install -pm 644 async-http-servlet-3.0/async-http-servlet-3.0/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-async-http-servlet-3.0.pom
# add_maven_depmap JPP.%{name}-async-http-servlet-3.0.pom %{name}/async-http-servlet-3.0.jar

# install -pm 644 eagledns/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-eagledns-fork.pom
# add_maven_depmap JPP.%{name}-eagledns-fork.pom %{name}/eagledns-fork.jar

# install -pm 644 profiling-tests/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-profiling-tests.pom
# add_maven_depmap JPP.%{name}-profiling-tests.pom %{name}/profiling-tests.jar

# APIDOCS
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}
#cp -rp target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%files
%{_javadir}/%{name}/*.jar
%{_mavenpomdir}/JPP.%{name}-*.pom
%{_mavendepmapfragdir}/%{name}
%doc License.html README.html

%files javadoc
%{_javadocdir}/%{name}

%changelog
* Thu Dec 1 2011 Ade Lee <alee@redhat.com> 1.0.0-1
- Initial packaging
